#include <stdlib.h>
#include <stdio.h>
#include "coord.h"

coord_list* newCoordList() {
	coord_list* new;
        new=(coord_list*)malloc(sizeof(coord_list));
        new->cursor=NULL;

	return new;
}

void delCoordList(coord_list* list) {
	
}

void addCoord(coord_list* list, monster* who, int x, int y) {
        coord_node *new, *temp;

        new=(coord_node*)malloc(sizeof(coord_node));
        new->who=who;
	new->x=x;
	new->y=y;

        if(list->cursor==NULL) {
                list->cursor=new;
                list->cursor->next=new;
        } else {
                temp=list->cursor->next;
                list->cursor->next=new;
                list->cursor->next->next=temp;
        }
}

void delCoord(coord_list* list, monster* who) {
	coord_node *cur, *prev;


        cur=prev=list->cursor;
        if(cur) {
                while(cur->who!=who) {
                        cur=cur->next;
                }
                while(prev->next!=cur) {
                        prev=prev->next;
                }
                if(cur!=prev) {
                        prev->next=cur->next;
                        free(cur);
                        cur=NULL;
                        list->cursor=prev->next;
                } else {
                        free(cur);
                        list->cursor=NULL;
                }
        } else {
                fprintf(stderr,"delCoord: there is no list\n");
        }                            

	decideGameControl(list);
}

int getX(coord_list* list, monster* who) {
	coord_node* temp;

	temp=list->cursor;
	while(temp->who!=who) {
		temp=temp->next;
	}
	return temp->x;
}

int getY(coord_list* list, monster* who) {
	coord_node* temp;

	temp=list->cursor;
	while(temp->who!=who) {
		temp=temp->next;
	}
	return temp->y;
}

monster* getMonster(coord_list* list, int x, int y) {
	coord_node *temp;
	
	temp=list->cursor;
	if(temp->x==x && temp->y==y) {
		return temp->who;
	} else {
		temp=temp->next;
		while(temp!=list->cursor) {
			if(temp->x==x && temp->y==y) return temp->who;
			temp=temp->next;
		}
		return NULL;
	}
	return NULL;
}

void coordMove(coord_list* list, int x, int y, int dx, int dy,
                   int teleport) {
	coord_node *temp;
	monster *who;

	if(!getMonster(list,x+dx,y+dy)) {
		if(who=getMonster(list,x,y)) {
			temp=list->cursor;
			while(temp->who!=who) {
				temp=temp->next;
			}
	
			if((teleport) || (abs(dx)<=1 && abs(dy)<=1)) {
				temp->x=x+dx;
				temp->y=y+dy;
			} else {
				fprintf(stderr,"coordMove: monster can't move that far without teleporting\n");
			}
		}
	} else {
		fprintf(stderr,"coordMove: a monster is in the way\n");
	}
}

void coordMoveMonster(coord_list* list, monster* who, int dx, int dy,
                      int teleport) {
	coordMove(list,getX(list,who),getY(list,who),dx,dy,teleport);
}
