#ifndef COORD_H
#define COORD_H

#include "monster.h"

typedef struct coord_node {
	monster*           who;
	int                x;
	int                y;
	struct coord_node* next;
} coord_node;

typedef struct coord_list {
	coord_node* cursor;
} coord_list;

coord_list* newCoordList();
void delCoordList(coord_list* list);

void addCoord(coord_list* list, monster* who, int x, int y);
void delCoord(coord_list* list, monster* who);

int getX(coord_list* list, monster* who);
int getY(coord_list* list, monster* who);

monster* getMonster(coord_list* list, int x, int y);
void coordMove(coord_list* list, int x, int y, int dx, int dy,
                   int teleport); 
void coordMoveMonster(coord_list* list, monster* who, int dx, int dy,
                      int teleport); 
/* if teleport==1 allow steps greater than 1 */

#endif /* COORD_H */
