#include <stdlib.h>
#include <stdio.h>
#include "map.h"

map* newMap() {
	map* new;
	int i,j;

	new=(map*)malloc(sizeof(map));

	for(j=0;j<MAX_MAP_Y;j++)
	for(i=0;i<MAX_MAP_X;i++) {
		new->cell[i][j]=(space*)malloc(sizeof(space));
		new->cell[i][j]->type=grass;
		new->cell[i][j]->mos=NULL;
	}
	
	return new;
}

void delMap(map* name) {

}

int gType(map* where, int x, int y) {
	return where->cell[x][y]->type;
}

void sType(map* where, int x, int y, int type) {
	where->cell[x][y]->type=type;
}

monster* gMos(map* where, int x, int y) {
	return where->cell[x][y]->mos;
}

void sMos(map* where, int x, int y, monster* who) {
	where->cell[x][y]->mos=who;
}

void mapAddMonster(map* where, monster* who, int x, int y) {
	if(!where->cell[x][y]->mos) {
		where->cell[x][y]->mos=who;
	} else {
		fprintf(stderr,"mapAddMonster: that space is taken\n");
	}
}

void mapDelMonster(map* where, int x, int y) {
	where->cell[x][y]->mos=NULL;
}

void mapMoveMonster(map* where, int x, int y, int dx, int dy, 
                    int teleport) {
	monster* who;

	if((teleport) || (abs(dx)<=1 && abs(dy)<=1)) {
		if(!gMos(where,x+dx,y+dy)) {
			who=gMos(where,x,y);
			sMos(where,x,y,NULL);
			sMos(where,x+dx,y+dy,who);
		} else {
			fprintf(stderr,"mapMoveMonster: that space is taken\n");
		}
	} else {
		fprintf(stderr,"mapMoveMonster: monster can't move that far without teleporting\n");
	}
}
