#ifndef MAP_H
#define MAP_H

#include <stdlib.h>
#include "monster.h"


#define MAX_MAP_X 16
#define MAX_MAP_Y 16

enum space_type {grass,stone};

typedef struct space {
	int      type;
	monster* mos;
} space;

typedef struct map {
	space* cell[MAX_MAP_X][MAX_MAP_Y];
} map;

map* newMap();
void delMap(map* name);

int gType(map* where, int x, int y);
void sType(map* where, int x, int y, int type);
monster* gMos(map* where, int x, int y);
void sMos(map* where, int x, int y, monster* who);

void mapAddMonster(map* where, monster* who, int x, int y);
void mapDelMonster(map* where, int x, int y);

void mapMoveMonster(map* where, int x, int y, int dx, int dy, 
                    int teleport);

#endif /* MAP_H */
